open Assertions
open Fields
open Utils
open Geometry
open Big_int

(* set of points with rational coordinates *)

let q1 = Q.num_of_int 1
let q2 = Q.num_of_int 2
let q3 = Q.num_of_int 3
let q4 = Q.num_of_int 4
let q5 = Q.num_of_int 5
let q6 = Q.num_of_int 6
let q7 = Q.num_of_int 7
let q8 = Q.num_of_int 8
let qhalf = Q.inverse q2
let qset1 = [(q1,q1); (q3,q1); (q3,q3); (q1,q3)]
let qset2 = [(q1,q1); (q3,q1); (q3,q3); (q2,q2); (q1,q3)]
(*vertices of a peterson graph *)
let qset3 =
          Q.([(negate q1, negate q3); (qhalf, negate q1); (q2, negate q3);
               (q1, negate qhalf); (q4, q1); (multiply q3 qhalf, qhalf); 
               (zero, q4); (qhalf, q3); (negate q1, q2); (negate q2, q1)])

(* set of points with real coordinates*)

let r0 = R.zero
let r1 = R.one
let r2 = R.num_of_int 2
let r3 = R.num_of_int 3
let r5 = R.num_of_int 5
let r6 = R.num_of_int 6
let r7 = R.num_of_int 7
let r8 = R.num_of_int 8
let r17 = R.num_of_int 17
let rhalf = R.inverse r2
let sqrt2 = sqrt r2
let pseudoe = R.(multiply (num_of_int 11) (inverse (num_of_int 4)))
(*equilateral triangle*)
let rset1 = R.([(r0, r0); 
                (add r1 (sqrt r3), add (negate r1) (sqrt r3));
                (add (negate r1) (sqrt r3), add r1 (sqrt r3))])
let rset2 = (r1,r1) :: rset1
let rset3 = R.([(r0,r0); (pseudoe, multiply sqrt2 rhalf);
               (negate (sqrt r5), sqrt2); 
               (negate (sqrt r6), negate (sqrt r3));
               (negate r1, negate (inverse r8));
               (add pseudoe (negate r1), negate (multiply (sqrt r5) rhalf));
               (negate (sqrt r7), negate r1);
               (negate (multiply sqrt2 (inverse r3)), sqrt r17);
               (negate rhalf, negate (multiply r3 rhalf));
               (negate r2, negate r3)])
