open Big_int
open Fields

(* This file contains the utility funtions for tests.ml *)

let leap_factor = big_int_of_int 10

let approx r n = r n

let sqrt x= 
    let ( * ) = mult_big_int in 
    let (+) = add_big_int in 
    let (-) = sub_big_int in 
    let (/) = div_big_int in 
    let rec isqrt (n:big_int ) : big_int = 
        if eq_big_int n zero_big_int then zero_big_int
        else let m = n / (big_int_of_int 4) in 
        let r = isqrt m in 
        let root = (big_int_of_int 2) * r + unit_big_int in 
        if le_big_int (root*root) n then root 
        else root - unit_big_int
    in 
    fun n -> 
        let n = leap_factor * n in
        let x_n = approx x n in 
        let p_n,q_n = x_n in 
        let two_n = (big_int_of_int 2) * n in 
        let a_n = p_n * two_n / q_n in 
        Q.multiply (Q.num_of_big_int (isqrt (a_n*two_n))) (Q.inverse (Q.num_of_big_int two_n))

let exp x = 
    (*cal_yn that calculates the partial sum for value x up to nth term*)
    let cal_yn x_n n = 
        let rec helper sum_acc x_term_acc fact_acc k = 
            if (k=n+1) then sum_acc 
            else 
            let x_term_acc = Q.(multiply x_term_acc x_n) in 
            let fact_acc = fact_acc * k in 
            let divisor = Q.(inverse (num_of_big_int (big_int_of_int fact_acc)))in 
            let sum_acc = Q.(add sum_acc (multiply divisor x_term_acc)) in 
            helper sum_acc x_term_acc fact_acc (k+1) 
        in 
    helper Q.one Q.one 1 1
    in 
    fun n -> 
        let x_n = approx x n in 
        cal_yn x_n (int_of_big_int n) 

